//******************
// amrc.c  For dsPic 
//******************

#include <p30f2012.h>
#include <adc12.h>
#include <uart.h>
#include <timer.h>
#include <ports.h>
#include "amrc.h"


// configuration
_FWDT(WDT_OFF);
_FGS(CODE_PROT_OFF);
_FOSC(CSW_FSCM_OFF & FRC_PLL16);
_FBORPOR(PBOR_OFF & PWRT_64 & MCLR_EN);

// A/D control register
unsigned int _ADCON1;
unsigned int _ADCON2;
unsigned int _ADCON3;
unsigned int _ADCHS;
unsigned int _ADPCFG;
unsigned int _ADCSSL ;

// UART control register
unsigned int _U1BRG;
unsigned int _U1MODE;
unsigned int _U1STA;
#define Fcy 7370000*4
#define BaudRate 115200
//--------------------------------------------------------------------------
#define ROSEN_NUM 0 //C{[hOF̑@1`@ɕύXăRpC
//--------------------------------------------------------------------------
#define RX_BYTE 100
#define TX_BYTE 100
#define TR_COUNT 6


// data
unsigned int ResultData;
unsigned int counter;
unsigned int int_counter;
unsigned int int_counter_com;
unsigned int int_counter_bak;
unsigned char rem_speed[8];
unsigned char speed[8];
unsigned char disp_speed[8];
unsigned char disp_speed_r[8];
unsigned char kukan[8];
unsigned char kukan_b[8];
int speed_out[8];
int speed_out_r[8];
int real_speed[8];
int recive_speed[8];
int send_speed[8];
unsigned int speed_sum[8];
int speed_err[8];
unsigned char avr_count[8];
unsigned char gnd_avr;
unsigned int gnd_level;
unsigned int gnd_sum;
unsigned char *data_ptr;
unsigned int kukan_chg;
unsigned char henka[8];
unsigned char henka_r[8];
unsigned char RecData[RX_BYTE];
unsigned char TxData[TX_BYTE];
unsigned char henka_count[8];
unsigned int debug[5];
unsigned char debug2[8];
unsigned char debug_b[10];
unsigned char cont_train[2];
unsigned char pre_cont_train[2];
unsigned char next_train[2];
unsigned char receive_data;
unsigned char receive_data_num;
unsigned char point[8];
unsigned char point_req;
unsigned char point_ret;
unsigned char chg_count[8];
unsigned char IntTxData[16];
unsigned char IntRxData[16];
unsigned char EnableBit[] ={1,2,4,8,16,32,64,128};
unsigned char TxAux[8];
unsigned int st_time;

unsigned int adc_n;
unsigned int adc_b;
int adc_back[8];
unsigned int int_pointer;
unsigned char send_data;
unsigned char henka_memo;

struct st_position train[8];
struct st_position train_r[8];
union scan_port kanshi;

void speed_cont(unsigned char);
void kukan_ON(unsigned char,unsigned char);
void kukan_OFF(unsigned char);
void kukan_henka(unsigned char);
void kukan_henkou(unsigned char);
void timer(unsigned char);

// Main routine
int main(void)
{
unsigned char n;
unsigned char p;
unsigned char sum;
unsigned char c;


	//PORTF=o
	TRISF=0;

	// Use Alternate Interrupt Vector Table
	INTCON2bits.ALTIVT=1;

	// UART1W[̃ItmF
	CloseUART1();
	// UART1荞ݐݒ
	ConfigIntUART1(	UART_RX_INT_DIS & UART_TX_INT_DIS);
	// UART1
	_U1BRG=	((Fcy/BaudRate)/16);
	// alternate I/O (U1ATX/U1ARX), N81
	_U1MODE=	UART_EN &
			UART_IDLE_CON &
			UART_ALTRX_ALTTX &
			UART_DIS_WAKE &
			UART_DIS_LOOPBACK &
			UART_DIS_ABAUD &
			UART_NO_PAR_8BIT &
			UART_1STOPBIT;
	_U1STA=	UART_INT_TX_BUF_EMPTY &
			UART_TX_PIN_NORMAL &
			UART_TX_ENABLE &
			UART_INT_RX_CHAR &
			UART_ADR_DETECT_DIS &
			UART_RX_OVERRUN_CLEAR;
	// Open UART1
	OpenUART1(_U1MODE, _U1STA, _U1BRG);


	// A/DϊW[ItmF
	ADCON1bits.ADON=0;
	// A/DϊW[
	_ADCHS=	ADC_CH0_POS_SAMPLEA_AN8 &
			ADC_CH0_NEG_SAMPLEA_NVREF;
	SetChanADC12(_ADCHS);
	ConfigIntADC12(ADC_INT_DISABLE);
	_ADCON1=ADC_MODULE_ON &
			ADC_IDLE_CONTINUE &
			ADC_FORMAT_INTG &
			ADC_CLK_AUTO &
			ADC_AUTO_SAMPLING_OFF &
			ADC_SAMP_OFF;
	_ADCON2=ADC_VREF_AVDD_AVSS &
			ADC_SCAN_OFF &
			ADC_SAMPLES_PER_INT_1 &
			ADC_ALT_BUF_OFF &
			ADC_ALT_INPUT_OFF;
	// Tad={Tcy(ADCS+1)}/2>334ns, Then ADCS>18.7, Tad=10*Tcy
	_ADCON3=ADC_SAMPLE_TIME_1 &
			ADC_CONV_CLK_SYSTEM &
			//ADC_CONV_CLK_10Tcy;
			ADC_CONV_CLK_5Tcy;
	_ADPCFG=ENABLE_AN8_ANA;
	_ADCSSL=SCAN_NONE;
	OpenADC12(_ADCON1, _ADCON2, _ADCON3, _ADPCFG, _ADCSSL);

#if ROSEN_NUM == 0
	//Timer1ݒ
	OpenTimer1(T1_ON & T1_GATE_OFF & T1_PS_1_1
				 & T1_SYNC_EXT_OFF & T1_SOURCE_INT, 586);//586//1172
	ConfigIntTimer1(T1_INT_PRIOR_5 & T1_INT_ON);
	//DisableIntT1;
	_TRISD9=0;
#else
	//RD9 Pin Interrupt ݒ
	//ConfigINT2(RISING_EDGE_INT & EXT_INT_ENABLE);
	ConfigINT2(FALLING_EDGE_INT & EXT_INT_ENABLE);
#endif

	_TRISD8=1;
	PORTF=0;

	train[0].NOW.BYTE = 0x78;
	train[1].NOW.BYTE = 0x78;
	train[2].NOW.BYTE = 0x78;
	train[3].NOW.BYTE = 0x78;
	train[4].NOW.BYTE = 0x78;
	
	point_req=0;
	kanshi.BYTE	= 0;
	gnd_level = 0x7cd;	//GND_LEVEL SET
	// main loop
	while(1)
	{
		while(U1STAbits.URXDA==0);	// wait RX data
		if(ReadUART1() == 0x55){
			while(U1STAbits.URXDA==0);	// wait RX data
			if(ReadUART1() == 0xAA){
				for(n=0;n<RX_BYTE;n++){
					while(U1STAbits.URXDA==0);	// wait RX data
					RecData[n] = ReadUART1();
				}
				//SUM CHECK
				sum=0;
				for(n=0;n<(RX_BYTE - 1);n++)
					sum += RecData[n];

				if(sum == RecData[RX_BYTE - 1]){
					//Mf[^̃Zbg
					for(n=0;n<TR_COUNT;n++){
						p=n*9;
						rem_speed[n] = RecData[p+1];
						if((RecData[p] & 1) != 0)	train[n].NOW.BYTE = RecData[p+2];
						if((RecData[p] & 2) != 0)	train[n].BEFOR.BYTE = RecData[p+3];
						if((RecData[p] & 4) != 0)	train[n].NEXT.BYTE = RecData[p+4];
						if((RecData[p] & 8) != 0)	train[n].ANEXT.BYTE = RecData[p+5];
						if((RecData[p] & 16) != 0)	henka[n] = RecData[p+6];
						if((RecData[p] & 32) != 0)	point[n] = RecData[p+7];
						TxAux[n] = RecData[p+8];
					}
				}
				//Mf[^̃Zbg
				for(n=0;n<TR_COUNT;n++){
					//if(henka[n] == 0xff)
					//	kukan_henkou(n);
					p=n*10;
					data_ptr=(unsigned char*) &real_speed[n];
					//TxData[p]=data_ptr[0];
					TxData[p]=disp_speed[n];
					TxData[p+1]=data_ptr[1];
					data_ptr=(unsigned char*) &kukan_chg;
					TxData[p+2]=data_ptr[0];
					TxData[p+3]=data_ptr[1];
					
					TxData[p+4]=train[n].NOW.BYTE ;
					TxData[p+5]=train[n].BEFOR.BYTE;
					TxData[p+6]=train[n].NEXT.BYTE;
					TxData[p+7]=train[n].ANEXT.BYTE;
					TxData[p+8]=henka[n];
					TxData[p+9]=point[n];
				}

				//䂷ԓo^(cont_train)
				pre_cont_train[0]=0xff;
				pre_cont_train[1]=0xff;
				for(n=0;n<TR_COUNT;n++){
					if((train[n].NOW.BIT.ROSEN == ROSEN_NUM) 
					 ||(train[n].NEXT.BIT.ROSEN == ROSEN_NUM)
					 ||(train[n].BEFOR.BIT.ROSEN == ROSEN_NUM))
						pre_cont_train[train[n].NOW.BIT.SOU]=n;
					
				}



				data_ptr=(unsigned char*) &debug[0];
				TxData[90]=data_ptr[0];
				TxData[91]=data_ptr[1];
				data_ptr=(unsigned char*) &debug[1];
				TxData[92]=data_ptr[0];
				TxData[93]=data_ptr[1];
				data_ptr=(unsigned char*) &debug[2];
				TxData[94]=data_ptr[0];
				TxData[95]=data_ptr[1];
				
				TxData[96]=debug_b[0];
				TxData[97]=debug_b[1];
				//debug2M
				for(n=0;n<8;n++)
					TxData[80+n] = debug2[n];
				//sumt
				sum=0;
				for(n=0;n<(TX_BYTE - 1);n++)
					sum += TxData[n];
				
				TxData[TX_BYTE - 1]=sum;

//				TxData[8]=debug[0];
//				TxData[9]=debug[1];
//				TxData[10]=debug[2];
//				TxData[11]=debug[3];

				// f[^PCɓ]܂
				for(n=0;n<TX_BYTE;n++){
					WriteUART1(TxData[n]);
					while(BusyUART1());
				}
			}
		}
	}
}

#if ROSEN_NUM == 0
	void __attribute__((__interrupt__, __shadow__, no_auto_psv)) _T1Interrupt(void)
#else
	void __attribute__((__interrupt__, __shadow__, no_auto_psv)) _INT2Interrupt(void)
#endif

{
	unsigned char n;
	unsigned char bn;//{[hԍ
	unsigned char c;
	unsigned char data_p;
	unsigned char bit_p;
//	unsigned char send_data;
	unsigned char dir;
	unsigned int reg1;
	int sp_d;
//	unsigned int adc_n;
//	unsigned int adc_b;

#if ROSEN_NUM == 0
	_T1IF = 0;
	//pXON
	_RD9=0;

//	debug[1]=ReadTimer1();
//	debug[1]=TxAux[0];

	st_time = ReadTimer1();
	_RD8=1;


#else
	_INT2IF = 0;
//	_TRISD8 = 0;
	_RD8=1;
//	_RF6=1;
#endif
	//ʐMpIntCounter
	if(++int_counter_com >= 0x800){
		int_counter_com = 0;
		#if ROSEN_NUM == 0
		//_RF6=1;		//IVEXT_Sync
		#endif
	}
	else{
	//pXOFF
		#if ROSEN_NUM == 0
			_RD9=1;
		#else
//			_RD8=0;
//			_RF6=0;
		#endif
	}
	int_counter=int_counter_com & 0x1ff;
	#if ROSEN_NUM == 0
		//IntPointSelect
		data_ptr=(unsigned char*) &int_pointer;
		data_ptr[0] = TxAux[0];
		data_ptr[1] = TxAux[1];
		if(int_counter_com == int_pointer)
			_RF6=1;		//IVEXT_Sync
	#endif
	


	#if ROSEN_NUM != 0
		//
		_RF6=1;
		if(_RD9==0){
			int_counter_bak = int_counter_com;
			int_counter_com =0;
		}
		data_ptr=(unsigned char*) &int_counter_bak;
		debug2[2]=data_ptr[0];
		debug2[3]=data_ptr[1];
		_RF6=0;
//		debug2[4]=cont_train[0];
//		debug2[5]=cont_train[1];
	#endif

	//Xs[hpXON
	n=0xff;
	if(int_counter == 0){
		cont_train[0] = pre_cont_train[0];
		n = cont_train[0];
	}
	if(int_counter == 0x100){
		cont_train[1] = pre_cont_train[1];
		n = cont_train[1];
	}
	

	if(n != 0xff){
		speed[n]=speed_out[n];
		//speed[n]=rem_speed[n] << 1;

		//pXON
		kukan[n]=train[n].NOW.BIT.KUKAN;
		kukan_b[n]=train[n].BEFOR.BIT.KUKAN;

		if(speed[n] != 0){
			dir = train[n].NOW.BIT.DIR;
			if(train[n].NOW.BIT.ROSEN == ROSEN_NUM)
				kukan_ON(kukan[n],dir);
			if(train[n].BEFOR.BIT.ROSEN == ROSEN_NUM)
				kukan_ON(kukan_b[n],dir);
		}
	}

	//Xs[hpXOFF
	//if(int_counter > 1){
		for(c=0;c<2;c++){
			n = cont_train[c];
			if(n != 0xff){
				if(speed[n] == 0){
					kukan_OFF(kukan[n]);
					kukan_OFF(kukan_b[n]);
				}
				else{
					speed[n]--;
				}
			}
		}
	//}

//	debug_b[0]=cont_train[0];
	debug_b[1]=cont_train[1];

	debug_b[0]=point_req;;
//	debug_b[1]=data_ptr[1];



	//f[^ʐM
	reg1=int_counter_com >> 1;
	bit_p = EnableBit[reg1 & 7];//bitʒuset
	reg1 >>= 3; 
	data_p = reg1 & 0xf;
	reg1 >>= 4; 
	bn = reg1 & 7;

	c=0;
//	if(reg1 & 8) c=1;
	if(data_p & 8) c=1;
	data_p &= 0x7;
	
	if(!(int_counter_com & 1)){//bit0=0 : send
		//f[^M
		if(bn == ROSEN_NUM){//{[h瑗M
			n=cont_train[c];
			//n=next_train[0];//nextԂ̃{[h]
			if(n != 0xff){
				_TRISB9=0;//B9 Output


				if(bit_p == 1)
					switch(data_p){
					case 0:
						send_data = n | 0xA0;//0xA0 Enable
						break;
					case 1:
						send_data=train[n].NOW.BYTE;
						break;
					case 2:
						send_data=train[n].BEFOR.BYTE;
						break;
					case 3:
						if(henka[n] & 0x1)
							send_data = (train[n].NEXT.BYTE & 0x7f) | 0x80;
						else
							send_data = train[n].NEXT.BYTE & 0x7f;
						break;
					case 4:
						send_data=(disp_speed[n] & 0x7f) | (henka[n] & 0x80);
						//send_data=disp_speed[n];
						break;
					//case 5:
					//	send_data=henka[n];
					//	break;
					case 5:
						data_ptr=(unsigned char*) &send_speed[n];
						send_data=data_ptr[0];
						break;
					case 6:
						data_ptr=(unsigned char*) &send_speed[n];
						send_data=data_ptr[1];
						break;
					case 7:
						data_ptr=(unsigned char*) &speed_out[n];
						send_data=data_ptr[0];
						break;
					//case 9:
					//	data_ptr=(unsigned char*) &speed_out[n];
					//	send_data=data_ptr[1];
					//	break;
					}
			
				if(send_data & bit_p)
					_RB9=1;
				else
					_RB9=0;
			}
		}

#if ROSEN_NUM == 1
		else
		if(bn == 6){//DebugM
			_TRISB9=0;//B9 Output
			if(debug2[data_p] & bit_p)
				_RB9=1;
			else
				_RB9=0;
		}
#endif

#if ROSEN_NUM == 0
		else
		if((bn == 7) && (data_p==0) && !c){//PointM
			_TRISB9=0;//B9 Output
			if(point_ret==0)
				if(bit_p == 1)
					send_data=point_req;

			if(send_data & bit_p)
				_RB9=1;
			else
				_RB9=0;
		}

#endif

		else
			_TRISB9=1;//B9 Input
		
	}

	else{//bit0=1 : Receive

#if ROSEN_NUM == 0
		if(bn != ROSEN_NUM && bn != 7){//̃{[hM
#else
		if(bn != ROSEN_NUM && bn != 6 && bn != 7){//̃{[hM
#endif
			//f[^M
			_TRISB9=1;//B9 Input
	
			if(_RB9)
				receive_data |= bit_p;
			else
				receive_data &= ~bit_p;
		
			if(bit_p == 0x80){
				//ŌbitI
				
				if(ROSEN_NUM == 0 && bn == 6){//master {[h ̂debug2M
					debug2[data_p]=receive_data;
				}
				else{
					if(data_p == 0){
						receive_data_num = receive_data;
						if((receive_data_num & 0xf0) == 0xA0) //0xA0@Enable
							receive_data_num &= 0xf;
						else
							receive_data_num = 0xff;
					}

					if(receive_data_num != 0xff){
						//̘Ĥݎ󂯓
						//if(ROSEN_NUM == 0)
						if(train[receive_data_num].NEXT.BIT.ROSEN != ROSEN_NUM)
							switch(data_p){
							case 1:
								train[receive_data_num].NOW.BYTE = receive_data;
								break;
							case 2:
								train[receive_data_num].BEFOR.BYTE = receive_data;
								break;
							case 3:
								train[receive_data_num].NEXT.BYTE = receive_data;
								train[receive_data_num].NEXT.BIT.DIR = train[receive_data_num].NOW.BIT.DIR;
								if(receive_data & 0x80) henka_memo= 1;
								else henka_memo= 0;

								break;
							case 4:
								//disp_speed[receive_data_num] = receive_data;
								disp_speed[receive_data_num] = receive_data & 0x7f;
								henka[receive_data_num] = henka_memo | (receive_data & 0x80);
								break;
							//case 5:
								//henka[receive_data_num] = receive_data;
							//	break;
							}
	
						switch(data_p){
						case 5:
							data_ptr=(unsigned char*) &recive_speed[receive_data_num];
							data_ptr[0] = receive_data;
							break;
						case 6:
							data_ptr=(unsigned char*) &recive_speed[receive_data_num];
							data_ptr[1] = receive_data;
							break;
						case 7:
							data_ptr=(unsigned char*) &speed_out_r[receive_data_num];
							data_ptr[0] = receive_data;
							data_ptr[1] = 0;
							break;
						}
					}
				}
			}
		}
#if ROSEN_NUM == 0
		else
		if(bn == 7 && data_p==2 && !c){//Point Receive
			_TRISB9=1;//B9 Input
	
			if(_RB9)
				receive_data |= bit_p;
			else
				receive_data &= ~bit_p;
		
			if(bit_p == 0x80){
				point_ret = receive_data;
				if(point_ret==point_req)
					point_req=0;
			}
		}
#endif
	}

#if ROSEN_NUM == 0
	if(int_counter == TxAux[0])
		debug[2]=ReadTimer1() - st_time;
#endif





	//ԕωo
	n = 0xff;
	if(int_counter == 0x5)
		n = cont_train[0];
	if(int_counter == 0x105)
		n = cont_train[1];
	
	if(n != 0xff){
		if(train[n].NEXT.BIT.ROSEN == ROSEN_NUM){
			//henka CLR mF
			if(henka[n] == 0){
				//kanshi.BIT.DISABLE=0;
				kanshi.BIT.KUKAN=train[n].NEXT.BIT.KUKAN;
				PORTF=kanshi.BYTE;
				//timer(0x8);
				//debug[2]=PORTF;
				// TvOJn܂
				ADCON1bits.SAMP=1;
				while(BusyADC12());
				kukan_chg=ReadADC12(0);
				//data_ptr=(unsigned char*) &kukan_chg;

				if((kukan_chg > 0xB00) || (kukan_chg < 0x400)){
						kukan_henka(n);
						//kukan_henkou(n);
				}
				else{
					henka_count[n]=0;
					//GND_LEVEL SET
					gnd_sum += kukan_chg;
					if(gnd_avr-- == 0){
						//gnd_level = gnd_sum >> 4;
						gnd_sum = 0;
						gnd_avr = 15;
					}
				}
			}
		}
	}

	//Xs[ho

	n=0xff;
	if(!(int_counter & 1)){
		if((int_counter >= 0x1c0) && (int_counter <= 0x1fe))
			n = cont_train[0];
		if((int_counter >= 0x0c0) && (int_counter <= 0x0fe))
			n = cont_train[1];
	}

	if(n != 0xff){
		if(int_counter & 0x2){
			if(train[n].NOW.BIT.ROSEN == ROSEN_NUM){
				//ԓǂݍ
				kanshi.BIT.KUKAN=train[n].NOW.BIT.KUKAN;
				PORTF=kanshi.BYTE;
				// TvOJn
				ADCON1bits.SAMP=1;
				while(BusyADC12());
				adc_n=ReadADC12(0);
				send_speed[n]=adc_n;
			}
			else
				adc_n = recive_speed[n];
				//adc_n=gnd_level;
		}
		else{
			if(train[n].BEFOR.BIT.ROSEN == ROSEN_NUM){
				//Oԓǂݍ
				//kanshi.BIT.DISABLE=0;
				kanshi.BIT.KUKAN=train[n].BEFOR.BIT.KUKAN;
				PORTF=kanshi.BYTE;
				//debug_b[1]=kanshi.BYTE;
				// TvOJn
				ADCON1bits.SAMP=1;
				while(BusyADC12());
				adc_b=ReadADC12(0);
				send_speed[n]=adc_b;
			}
			else{
//					if(train[n].NEXT.BIT.ROSEN == ROSEN_NUM)
//						adc_b = gnd_level;
//					else
					adc_b = recive_speed[n];//BEFOREH
			}
		}

		if(int_counter & 0x2){
			//Oadclr
			if(train[n].NOW.BIT.DIR == 0){	//
				if(adc_b>adc_n)
					adc_n=adc_b;
			}
			else{
				if(adc_b<adc_n)
					adc_n=adc_b;
			}
			
			
			//if(train[n].BEFOR.BIT.ROSEN == ROSEN_NUM)
			//	send_speed[n]=adc_n;
			
			
			if((adc_back[n]>0x810) || (adc_back[n]<0x7c0)){
				sp_d = adc_n - gnd_level;
				if(sp_d < 0) sp_d = -sp_d;
				//̎
				if(sp_d < 0x10)
					adc_n = adc_back[n];
			}

			speed_sum[n]+=adc_n;
			
			if(n=1){
				debug[0]=adc_n;
				debug[1]=adc_b;
				debug[2]=speed_out[1];
			}
		}

	}

	_RF6=0;

	//Ϗ
	n = 0xff;
	if(int_counter == 0x1b8)
		n = cont_train[0];
	if(int_counter == 0x0b8)
		n = cont_train[1];
	
	if(n != 0xff){
		speed_sum[n] >>= 4;
		adc_back[n] = speed_sum[n];
		
		if(train[n].NOW.BIT.DIR == 0)	//
			real_speed[n] = speed_sum[n] - gnd_level;
		else
			real_speed[n] = gnd_level - speed_sum[n];
		
		if(real_speed[n] > 0)
			disp_speed[n] = real_speed[n] >> 3;		//\Xs[h
		else
			disp_speed[n] = 0;
		
		if(real_speed[n] <0)
			real_speed[n]=0;
		
//		if(gnd_level == 0)
//			gnd_level = 0x7f0;	//GND_LEVEL SET

		if(rem_speed[n]==0){
			adc_back[n] = gnd_level;
		}

#if ROSEN_NUM != 0
		data_ptr=(unsigned char*) &gnd_level;
		debug2[0]=data_ptr[0];
		debug2[1]=data_ptr[1];
		data_ptr=(unsigned char*) &speed_sum[0];
//		debug2[2]=data_ptr[0];
//		debug2[3]=data_ptr[1];
#endif

		speed_sum[n]=0;
		//speed_cont(n);
	}

	//SpeedCont
	n = 0xff;
	if(int_counter == 0x1ba)
		n = cont_train[0];
	if(int_counter == 0x0ba)
		n = cont_train[1];

	if(n != 0xff)
		speed_cont(n);




#if ROSEN_NUM == 0
	//Point Cont
	if((int_counter >= 0x50) && (int_counter < 0x50+TR_COUNT)){
		n = int_counter - 0x50;
		if(!point_req){
			if((point[n] & 0x80) !=0){
				point_req = point[n];
				point[n] = 0;
			}
		}
	}


#endif


	//pXOFF
	if(int_counter_com == 0){
		#if ROSEN_NUM == 0
			_RD9=1;
		#else
			_RD8=0;
		#endif
	}
	_RF6=0;
	_RD8=0;

}

void kukan_henka(unsigned char n){
	if(henka_count[n] >= 1){	//ω
		//ԕύX
		train[n].BEFOR.BYTE = train[n].NOW.BYTE;
		train[n].NOW.BYTE = train[n].NEXT.BYTE;
		train[n].NEXT.BYTE = train[n].ANEXT.BYTE;
		henka[n]=0x80;
	}
	else
		henka_count[n]++;
	
}

void kukan_henkou(unsigned char n){

	train[n].BEFOR.BYTE = train[n].NOW.BYTE;
	train[n].NOW.BYTE = train[n].NEXT.BYTE;
	train[n].NEXT.BYTE = train[n].ANEXT.BYTE;
	henka[n]=0x80;
	

}

void kukan_ON(unsigned char kukan,unsigned char d){
// d=0:], 1:]

	if(d==0)
		LATB |= EnableBit[kukan];
	else
		LATB &= ~EnableBit[kukan];

	TRISB &= ~EnableBit[kukan];
	
}

void kukan_OFF(unsigned char kukan){

	TRISB |= EnableBit[kukan];

}


void speed_cont(unsigned char n)
{
	int err;
	int err_abs;	/*errΒl*/
	int err_def;
	int k1=0x4;	/*xP18*/
	int k2=0x2;
	int d;
	int rsp;
	
	rsp = rem_speed[n];
	rsp <<= 2;
	err = rsp - real_speed[n];/* r */

#if ROSEN_NUM != 0
	data_ptr=(unsigned char*) &err;
//	debug2[4]=0xaa;
//	debug2[5]=0xbb;
//	debug2[4]=data_ptr[0];
//	debug2[5]=data_ptr[1];
#endif

	if(err<0)
		err_abs=-err;
	else
		err_abs=err;
	
	err_def = err_abs - speed_err[n];/* errr */
	speed_err[n] = err_abs;
	
	if(err_def<0){
		/*k1=k1 - err_def*k2;	err*/
		k1 = k1 - k2;	/*err*/
		if(k1<0)
			k1=0;
	}
	else{
		/*k1=k1 + err_def*k2;	err*/
		k1 = k1 + k2;	/*err*/
	}	
	

	d = (err * k1) / 0x100;

	if(rem_speed[n]==0){
		if(d>-0x10)
			d=-0x10;	/*~*/
	}

	speed_out[n] += d;


	//Hς菉
	if(train[n].BEFOR.BIT.ROSEN != train[n].NOW.BIT.ROSEN){
		if(train[n].BEFOR.BIT.ROSEN != ROSEN_NUM){
			if(chg_count[n]++ < 50)
				speed_out[n] = speed_out_r[n];
			else
				chg_count[n] = 50;
		}
	}
	else
		chg_count[n] = 0;


//	debug[0]=chg_count[0];
//	debug[1]=speed_out_r[0];
		
	if(speed_out[n]<0)
		speed_out[n]=0;

	//Speed Limiter
	if(speed_out[n]>0xc0)
		speed_out[n]=0xc0;


}


void timer(unsigned char n){
	while(--n != 0){}
}

void timer_l(unsigned int n){
	while(--n != 0){}
}
